(******************************************************************************)
(* computer basics                                                            *)
(* (C) 2010 Steffen Solyga <solyga@absinth.net>                               *)
(******************************************************************************)
DEFINITION MODULE Comp0;

FROM SYSTEM IMPORT BYTE;

TYPE
  TValue = LONGINT;
  TIndex = CARDINAL;
  TOperation = (
    oWrt, oWrC, oNeg,
    oAdd, oSub, oMul, oDiv, oBus, oVid,
    oEql, oNeq, oLss, oLeq, oGtr, oGeq,
    oNot, oOr,  oAnd
  );
  TAddress = CARDINAL;

  TFunction = ( fHlt, fVal, fLod, fSto, fOpr, fJmp, fJpf, fJpt );
  TCmdDesc = RECORD
    CASE fct: TFunction OF
    | fHlt      : (* empty *)
    | fVal      : val: TValue;
    | fLod, fSto: idx: TIndex;
    | fOpr      : opr: TOperation;
    | fJmp..fJpt: adr: TAddress;
    END;
  END;

  TSet = SET OF [ 0 .. 8*SIZE(TValue)-1 ];

CONST
  aNone = MAX( TAddress );

  acMax = 32;    (* arguments (stack) *)
  vcMax = 64;    (* variables / TIndex *)
  pcMax = 1024;  (* program / TAddress *)

TYPE
  TProgram = ARRAY [ 0 .. pcMax - 1 ] OF BYTE;

  TCmdStr = ARRAY [ 0 .. 15 ] OF CHAR;

PROCEDURE Convert( cmd: TCmdDesc; VAR str: TCmdStr );

END Comp0.
