(******************************************************************************)
(* generator (stack machine with condition register)                          *)
(* (C) 2010 Steffen Solyga <solyga@absinth.net>                               *)
(******************************************************************************)
DEFINITION MODULE Gen;

IMPORT Comp0;
FROM Scnr IMPORT TSymbol;

TYPE
  TValue   = Comp0.TValue;
  TIndex   = Comp0.TIndex;
  TAddress = Comp0.TAddress;

  TType = ( tBool, tInt );
  TMode = ( mConst, mVar, mStack, mCond );
  TItemDesc = RECORD
    t: TType;
    CASE m: TMode OF
    | mConst: v: TValue;
    | mVar  : i: TIndex;
    | mStack:
    | mCond : c: BOOLEAN;
              a: TAddress;  (* false *)
              b: TAddress;  (* true *)
    END;
  END;

PROCEDURE Hlt();

PROCEDURE Init( VAR a: TAddress );
PROCEDURE Jmp( VAR a: TAddress );
PROCEDURE Fixup( a: TAddress );

PROCEDURE Label( VAR a: TAddress );
PROCEDURE JmpFalse( VAR x: TItemDesc );
PROCEDURE FixWith( v, a: TAddress );

PROCEDURE Wrt( x: TItemDesc );
PROCEDURE Op1( s: TSymbol; VAR x: TItemDesc );
PROCEDURE Op2( s: TSymbol; VAR x: TItemDesc; y: TItemDesc );
PROCEDURE Asg( x, y: TItemDesc );


CONST
  vFalse = 0;
  vTrue  = 1;

END Gen.
