(******************************************************************************)
(* plx scanner                                                                *)
(* (C) 2010 Steffen Solyga <solyga@absinth.net>                               *)
(******************************************************************************)
DEFINITION MODULE Scnr;

IMPORT FIO;

TYPE
  TSymbol = (
    sNull, sNum, sId, (* sExcl, *)
    sCol, sBec, sLPar, sNot,
    sMul, sDiv, sAnd,                   (* mulop *)
    sPlus, sMinus, sOr,                 (* addop *)
    sEql, sNeq, sLss, sLeq, sGtr, sGeq, (* relop *)
    sRPar, sSemi, sDot,
    sConst, sVar, sBeg, sEnd, sWrt,
    sRepeat, sUntil, sIf, sThen, sElse, sElsif, sWhile, sDo,
    sEOF
  );

  TPosDesc = RECORD
    l,c: CARDINAL;
  END;

VAR
  src: FIO.File;
  sym: TSymbol;
  num: LONGCARD;
  id : CARDINAL;
  pos: TPosDesc;

PROCEDURE Put( s: ARRAY OF CHAR );
PROCEDURE Read();
PROCEDURE KeepId();
PROCEDURE Diff( x, y: CARDINAL ): INTEGER;

END Scnr.
